clear all; close all;
%Crank-Nicholson for the one-dimensional heat equation
%set up parameters
b=1;
J=1001;
delx=1/(J-1);
u=ones(1,J);%initial condition
uplot=[u];
delt=500*delx^2;
nt=fix(0.5/delt);
mu=b*delt/delx^2;
%
%create vectors for Thomas algorithm - this could be outside the time
%loop - for indexing reasons, we are using a(1)=0, c(J)=0; that way
%the Thomas function is easier to write - these do not occur explicitly
%in the Thomas algorithm but allow a(2) to line up with b(2), etc.
    b=(1+mu)*ones(J,1);b(1,1)=1.0;b(J,1)=1.0;
    %
    a=-mu/2*ones(J,1);a(1,1)=0.;a(J,1)=0.0;
    %
    c=-mu/2*ones(J,1);c(1,1)=0.;c(J,1)=0.0;
%loop over time
for it=1:nt
    %set up the right hand side vector - this should be in the time loop
    time=(it-1)*delt;
    rhs(1)=0.0;
    for j=2:J-1
        rhs(j)=mu/2*u(j+1)+(1-mu)*u(j)+mu/2*u(j-1);
    end
    rhs(J)=0;
    %call Thomas algorithm
    unext=thomas(a,b,c,rhs);
    %
    u=unext;
    %plot
 x=linspace(0,1,J);
 plot(x,u)
 ylim([0 1])
 pause(0.001)
   
end